######################################################################
# pyukiwiki.ini.cgi - This is PyukiWiki, yet another Wiki clone.
# $Id: pyukiwiki.ini.cgi,v 1.549 2012/03/01 10:39:19 papu Exp $
#
# "PyukiWiki" version 0.2.0-p2 $$
# Copyright (C) 2004-2012 Nekyo
# http://nekyo.qp.land.to/
# Copyright (C) 2005-2012 PyukiWiki Developers Team
# http://pyukiwiki.sfjp.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sfjp.jp/
# License: GPL3 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return:LF Code=EUC-JP 1TAB=4Spaces
######################################################################

use strict;

# 
$::lang = "ja";				# ja:ܸ/en:Ѹ()
$::kanjicode = "euc";		# euc:EUC-JP/sjis:ShiftJIS/utf8:UTF-8
#$::charset = "utf-8";		# UTF8ư硢ͭ

# 쥳Ѵ			# Jcode Only!!
$::code_method{ja}="Jcode";	# ja : Jcode

# ǡǼǥ쥯ȥ
$::data_home = '.';		# CGIΤߥǡΥǥ쥯ȥ
$::data_pub = '.';		# ֥饦鸫ǡΥǥ쥯ȥ
$::data_url = '.';		# ֥饦СХǥ쥯ȥ
$::bin_home = '.';		# ̾ѹʤǲ

# cgi-bin̤Υǥ쥯ȥ
# for sourceforge.jp
# /home/groups/p/py/pyukiwiki/htdocs
# /home/groups/p/py/pyukiwiki/cgi-bin
#$::data_home = '.';
#$::data_pub = '../htdocs';
#$::data_url = '..';

# Windows NT Server (IIS+ActivePerl)ξ
#$::data_home = 'C:/inetpub/cgi-bin/pyuki/';
#$::data_pub = 'C:/inetpub/cgi-bin/pyuki/';
#$::data_url = '.';

$::data_dir    = "$::data_home/wiki";		# ڡǡ¸
$::backup_dir  = "$::data_home/backup";		# Хåå¸
$::diff_dir    = "$::data_home/diff";		# ʬ¸
$::cache_dir   = "$::data_pub/cache";		# 
$::cache_url   = "$::data_url/cache";		# 
$::upload_dir  = "$::data_pub/attach";		# ź
$::upload_url  = "$::data_url/attach";		# źURL
$::counter_dir = "$::data_home/counter";	# 
$::plugin_dir  = "$::data_home/plugin";		# ץ饰
$::explugin_dir= "$::bin_home/lib";			# ץ饰
$::skin_dir    = "$::data_pub/skin";		# 
$::skin_url    = "$::data_url/skin";		# URL
$::image_dir   = "$::data_pub/image";		# 
$::image_url   = "$::data_url/image";		# URL
$::info_dir    = "$::data_home/info";		# 
$::res_dir     = "$::data_home/resource";	# ꥽
$::sys_dir	   = $::explugin_dir;			# ƥ

# ̾
$::skin_name   = "pyukiwiki";
$::use_blosxom=0;	# blosxom.cssѤȤˤ

# ưŪåȥåץե
# pyukiwiki.ini.cgiѹʬΤߤsetup.ini.cgi˵ܤ뤳Ȥǡ
# ΥåץǡȤưפˤʤޤ
$::setup_file	= "$::info_dir/setup.ini.cgi" if($::setup_file eq '');

# ץ
#$::proxy_host = '';
#$::proxy_port = 3128;

# wikiԾ (ѿθ̾Ϣˤȡ̤ˤǤޤ
$::wiki_title = '';										# ̾ʤʤƤġ
#$::wiki_title{en}='';									# ѸΥȥ(sample)
$::modifier = 'anonymous';								# ̾
$::modifierlink = '';									# URI
$::modifier_mail = '';									# ԥ᡼륢ɥ쥹
$::meta_keyword="$::wiki_title";						# 

# 1:ȥοƳؤά, 0:άʤ
$::short_title=0;

# 
$::logo_url="$::image_url/pyukiwiki.png";				# URL
$::logo_width=80;										# 
$::logo_height=80;										# ⤵
$::logo_alt="[PyukiWiki]";								# ʸ

# ץ̾
# servererrorurlhackץ饰ѤϡưǤϤʤ
# $::scriptɬꤷƲ
#$::script			= 'index.cgi';
$::script			= '';								# ư

# URL
#$::basehref		= 'http://hogehoge/path/index.cgi';	# ư
$::basehref			= '';

# ѥ (cookie)
#$::basepath		= '/path';							# ư
$::basepath			= '';

# ǥեȥڡ̾
$::FrontPage		= 'FrontPage';
$::RecentChanges	= 'RecentChanges';
$::MenuBar			= 'MenuBar';
$::SideBar			= ':SideBar';
$::TitleHeader		= ':TitleHeader';
$::Header			= ':Header';
$::Footer			= ':Footer';
$::BodyHeader		= ':BodyHeader';
$::BodyFooter		= ':BodyFooter';
$::SkinFooter		= ':SkinFooter';					# PyukiWiki
														# (c)˺ܤ

$::InterWikiName	= 'InterWikiName';
$::ErrorPage		= "ErrorPage";
$::AdminPage		= "AdminPage";
$::IndexPage		= "IndexPage";
$::SearchPage		= "SearchPage";
$::CreatePage		= "CreatePage";

# ԥѥ (̥ѥɡ
$::adminpass = crypt("pass", "AA");

# ѥɤ̤ˤ
#̥ѥɤǤǧڤޤ̤Ѥʤ¬ʥѥϡ
#$::adminpass = 'aetipaesgyaigygoqyiwgorygaeta';# ǥեȤѻѥǥǽѥ
#$::adminpass{admin} = crypt("admin","AA");		# ѥѥɡ
#$::adminpass{frozen} = crypt("frozen","AA");	# ѥѥ
#$::adminpass{attach} = crypt("attach","AA");	# źѥѥ

# ѥɤʰװŹ沽롣
$::Use_CryptPass=1;

# ꥹ
#$::lang_list="ja en cn";

# RSS
$::rss_lines=15;								# RSSϹԿ
$::rss_description_line=1;						# descriptionιԿ
												# 12ʾǤưۤʤ


# RSS (ѿθ̾Ϣˤȡ̤ˤǤޤ
$::modifier_rss_title=$::wiki_title;			# RSSɽ
$::modifier_rss_link='';						# RSSʼư
$::modifier_rss_description = "Modified by $::modifier";	# RSS

#$::modifier_rss_title = "PyukiWiki $::version";
#$::modifier_rss_link = 'http://pyukiwiki.sfjp.jp/';
#$::modifier_rss_description = 'This is PyukiWiki.';

# Exץ饰
$::useExPlugin = 1;		# explugin 1:Ȥ/0:Ȥʤ

# HTMLϥ⡼
$::htmlmode="html4";	# html4        : //W3C//HTML 4.01 Transitional
						# xhtml10      : //W3C//XHTML 1.0 Strict
						# xhtml10t     : //W3C//XHTML 1.0 Transitional
						# xhtml11      : //W3C//XHTML 1.1
						# xhtmlbasic10 : //W3C//DTD XHTML Basic 1.0

# Хååפλ
$::useBackUp=1;

# ɽ
$::usefacemark = 1;		# եޡ 1:Ȥ/0:Ȥʤ
$::use_popup = 1;   	# 
						# 0:̤˥󥯤
						# 1:ݥåץå (target=_blank)
						# 2:HTTP_HOSTӤơƱʤ̤
						# 3:$basehrefӤƱʤ̤
						# (wikiʲΥڡΤߡưʤС⤢ޤ)
						# (Ԥcookie0/1-3)
$::line_break = 0;		# wikiʸǥեȤǲԤ 1
						# (0ξ硢&br;~Ū˲Ԥɬפޤǥե)
$::last_modified = 2;	# ǽ 0:ɽ/1:ɽ/2:ɽ
$::lastmod_prompt = 'Last-modified:'; # ǽΥץץ
$::allview = 1;			# 1:٤Ƥβ̤Header, MenuBar, Footerɽ, 0:ʤ

$::notesview = 0;		#  0:$bodyβɽ ,1:footerξɽ, 2:footerβɽ
$::enable_convtime = 1;	# Сȥ 1:ɽ/0:ɽ(perlversionɽޤ)

$::diff_disable_email = 1;# diffڤӥХååץץ饰ˤƥ᡼륢ɥ쥹򱣤
$::backup_disable_email = 1;# Хååץץ饰Υɽˤƥ᡼륢ɥ쥹򱣤

# եޥå
$::date_format = 'Y-m-d'; 			# replace &date; to this format.
$::time_format = 'H:i:s'; 			# replace &time; to this format,
$::now_format="Y-m-d(lL) H:i:s";	# replace &now; to this format.
$::lastmod_format="Y-m-d(lL) H:i:s";# lastmod format
$::recent_format="Y-m-d(lL) H:i:s";	# RecentChanges(?cmd=recent) format
$::backup_format="Y-m-d(lL) H:i:s"; # backup list format
$::attach_format="Y-m-d(lL) H:i:s";	# attach info
$::ref_format="Y-m-d(lL) H:i:s";	# ref info

#$::lastmod_format="yǯnj(lL) ALgkʬS";	# ܸɽ

	# ǯ  :Y:(4)/y:(2)
	#   :n:1-12/m:01-12/M:Jan-Dec/F:January-December
	#   :j:1-31/J:01-31
	# :l:Sunday-Saturday/D:Sun-Sat/DL:-/lL:-
	# ampm:a:am or pm/A:AM or PM/AL: or 
	#   : g:1-12/G:0-23/h:01-12/H/00-23
	# ʬ  : k:0-59/i:00-59
	#   : S:0-59/s:00-59
	# O   : ˥åȤλֺ
	# r RFC 822 եޥåȤ줿 : Thu, 21 Dec 2000 16:01:07 +0200
	# Z ॾΥեåÿ -43200  43200
	# L ǯǤ뤫ɤɽ͡ 1ʤ鱼ǯ0ʤ鱼ǯǤϤʤ
	# lL:ߤΥθǤû
	# DL:ߤΥθǤĹ
	# aL:ߤΥθǤθʸ
	# AL:ߤΥθǤθʾʸ
	# t ꤷ 28  31
	# B Swatch 󥿡ͥåȻ 000  999
	# U Unix (1970ǯ1100ʬ0)ÿ See also time()

# ڡԽ
$::cols = 80;			# ƥȥꥢΥ
$::rows = 25;			# ƥȥꥢιԿ
$::extend_edit = 1;		# ĥǽ(JavaScript) 1:/0:̤
$::pukilike_edit = 3;	# PukiWiki饤Խ
						# 0:Pyukiwiki/1:PukiWiki/2:PukiWiki+ɤ߹ߵǽ
						# 3:PukiWiki+Τ߿ɤ߹ߵǽ
$::edit_afterpreview=1;	# ץӥ塼 0:Խ̤ξ 1:Խ̤β
$::new_refer='[[$1]]';	# ξ硢ϢڡΥ󥯤ͤȤɽ
#$::new_refer='';			# ʸˤɽޤ
$::new_dirnavi=1;		# ڡ̤ǡɤΥڡβؤ뤫
						# Ǥ褦ˤ 1:/0:̤
$::write_location=1;	# ڡԽ塢locationǰư
						# ̵ǤŽ񤭹ߤˤϤʤޤ󤬡äƥɥܥ
						# ȤΥ֥饦ηٹ˻ߤǤޤ
						# ̵СϤǤϡ0ˤʤưޤ
$::partedit=1;			# ʬԽ0:Ȥʤ 1:Ȥ 2:ڡ 3:
$::partfirstblock=0;	# 1:ǽθФʬ1ܤθФȤߤʤԽǤ褦ˤ
$::usePukiWikiStyle=1;	# PukiWIki񼰤 0:Ȥʤ 1:Ȥ
$::writefrozenplugin=1;	# Ǽ뤵ƤڡǤץ饰󤫤񤭹褦ˤ롣
						# 0:Բ 1:
$::newpage_auth=0;		# ڡ 0:ïǤǤ, 1:ѥɤɬ
						# ץ饰󤫤뿷ڡˤŬѤޤ
$::use_escapeoff=2;		# IEˤơäESC򲡤ơϤƤü
						# Τ˻ߤ롣
						# 2 ˤȡsetting.inc.cgi ǥǥեȤͭˤʤ롣

$::setting_savename=0;	# setting.inc.cgi ˤơǼ̾¸1 
						# ǥեȤͭˤ롣setting.inc.cgiͭΤߵǽ

# ư
$::nowikiname = 0;		# 0:WikiNameư 1:Ū [[ ]] ɬ
$::autourllink = 1;		# URLμư ([[ ]] Ū˻ꤵ줿ΤϤΤ)
$::automaillink = 1;	# ᡼륢ɥ쥹μư ([[ ]] Ū˻ꤵ줿ΤϤΤ)
$::useFileScheme=0;		# 0:̾, 1:file:// Υޤͭˤʥȥͥåȸ
$::IntraMailAddr = 0;	# 1:ȥͥåȸΥɥᥤʤ᡼륢ɥ쥹ͭ
$::use_autoimg = 1;		# URLǤС̵ imgĥ

# å
$::cookie_expire=3*30*86400;	# ¸cookieͭ(3)
$::cookie_refresh=86400;		# ¸cookieΥեåֳ()


# 󥿡
$::CounterVersion=1;	# 1:ȺΤ¸2:ʬ¸
$::CounterDates=365;	# ¸(141000)
$::CounterHostCheck=1;	# 1:󥿡Υ⡼ȥۥȤå/0:ɤǤ⥫Ȥ

# ź
$::file_uploads = 2;		# źդ 0:Ȥʤ/1:Ȥ/2:ǧդ/3:Τǧ
$::max_filesize = 1000000;	# åץɥե
$::AttachFileCheck=1;		# źեեƴƺ 0:ĥҤΤ/1:ƴƺ⤹
							# 0ξ硢ƥˤʤΤ
							# Ǥ륤ȥ(local)ͥåȰʳǤϻѤʤǲ
$::AttachCounter=0;			# źեեΥȤ򤹤(1)ɽ⤹(2)

# إ
$::use_HelpPlugin=1;	# إפץ饰Ǽ¹ԤʥʥӥѲޤ
						# إץڡԽ
						# ?cmd=adminedit&mypage=%a5%d8%a5%eb%a5%d7 
						# UTF-8ǤǤ
						# ?cmd=adminedit&mypage=?%e3%83%98%e3%83%ab%e3%83%97 

$::no_HelpLink=0;		# إפΥ󥯤ɽʤ
						# (ƱԽʤڡͭǤ

# 
$::use_FuzzySearch=1;	# 0:̾︡/1:ܸ줢ޤѤ
$::use_Highlight=1;		# 1:Ĵɽ򤹤롣

# ȥޥå
$::use_SiteMap=0;		# 0:ListΤ/1:List,ȥޥåξ

# ʥӥ
$::naviindex=1;			# 0:ɡ / 1:ȥåס

# ڡ̾βtopicpathλ
$::useTopicPath=1;		# 0:Ѥʤ / 1:Ѥ
						# ڡΥץ饰ƤӽФˤϱƶޤ

# ѥ졼			# ػ
$::separator='/';

# ɥå
$::dot='.';

# βġС
$::toolbar=2;			# 0:ɽʤ 1:RSSΤ 2:٤ɽʬԽΥ

# ԴĶ굡ǽȤ
$::use_Setting=1;

# 󥻥쥯Ȥ
$::use_SkinSel=1;

$::_symbol_anchor = '&dagger;';
$::maxrecent = 50;

# ˴ޤʤڡ̾(ɽ)
$::non_list = qq((^\:|$::separator\:));
#$::non_list = qq((^\:));
#$::non_list = qq((^\:|$::MenuBar\$)); # example of MenuBar

# źեեڡΰ嵭ɽǻꤷڡ
$::attach_nonlist = 1;

# gzip ѥŪ˻ꤹ롣
# ꤷʤϡgzipѥư
# ǤʤСCompress::Zlib Ѥޤ
#$::gzip_path = '/bin/gzip -1';			# fast
#$::gzip_path = '/usr/bin/gzip -1 -f';	# fast
#$::gzip_path = '/bin/gzip -9';			# max compress
#$::gzip_path = '/usr/bin/gzip -9 -f';	# max compress
#$::gzip_path = 'nouse';				# Ѥʤ
										# ưʤ祳ȥ

# sendmailѥλ $::modifier_mailƤ˥᡼
$::modifier_sendmail=<<EOM;
/usr/sbin/sendmail -t
/usr/bin/sendmail -t
/usr/lib/sendmail -t
/var/qmail/bin/sendmail -t
EOM

# WikiΤͤΤ餻 1
$::sendmail_to_admin = 0;

# UTF-8᡼  MIME::Base64ɬ
$::send_utf8_mail=0;

# P3PΥѥȥݥꥷ http://fs.pics.enc.or.jp/p3pwiz/p3p_ja.html
# ɬפǤ /w3cʲǥ쥯ȥˤŬڤ˥ե֤ͭˤޤ
#$::P3P="NON DSP COR CURa ADMa DEVa IVAa IVDa OUR SAMa PUBa IND ONL UNI COM NAV INT CNT STA";

# ʥӥ˥󥯤ɲä륵ץ
#push(@::addnavi,"link:help");		# helpɲ
##push(@::addnavi,"link::help");	# helpθɲ
#$::navi{"link_title"}="󥯽";
#$::navi{"link_url"}="$::script?%a5%ea%a5%f3%a5%af";	# page of ''
#$::navi{"link_name"}="󥯽";
#$::navi{"link_type"}="page";
#$::navi{"link_height"}=14;
#$::navi{"link_width"}=16;

# ե륿Ϣ
$::filter_flg = 1;					# 1ǥե륿ǽͭˤ롣
$::chk_uri_count = 10;				# 쥪ץ
$::chk_wiki_uri_count = 10;			# Խ̤ǥۡڡɥ쥹
									# 10İʾˤʤȥѥȤߤʤ
$::chk_article_uri_count = 1;		# Ǽǥۡڡɥ쥹
									# ġʸĿˤǤ⤢ȥѥȤߤʤ
$::chk_article_mail_count = 1;		# Ǽǥ᡼륢ɥ쥹
									# ġʸĿˤǤ⤢ȥѥȤߤʤ
$::chk_write_jp_only = 0;			# Խ̤ܸ줬äƤʤ
									# ѥȤߤʤ
									# ʤǥեȤϥץ饰
									# եѸΥڡ
									# 褦OFFˤƤ롣
$::chk_jp_only = 1;					# Ǽġܸ줬
									# äƤʤȥѥȤߤʤ
$::deny_log = "$::cache_dir/deny.log";
									# ե롣
									# ꤵƤȥ롣
									# ̵Ƥʤ

$::black_log = "$::cache_dir/black.lst";
									# ե륿ե饰դƤȤ
									# 

# ॾ

$::TZ='';							# ư
#$::TZ='9';							# ΤϤ䤤⡩ѡ

# 񤭹߶ػߥ
$::disablewords=<<EOM;
example.com
EOM

1;

__END__

